"use strict";

function _typeof(obj) { if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.CounterMeter = void 0;

var _react = _interopRequireDefault(require("react"));

var _propTypes = _interopRequireDefault(require("prop-types"));

var R = _interopRequireWildcard(require("ramda"));

var _styles = require("@material-ui/core/styles");

var _Caption = require("./Caption");

var _uiUtils = require("../ui-utils");

function _getRequireWildcardCache() { if (typeof WeakMap !== "function") return null; var cache = new WeakMap(); _getRequireWildcardCache = function _getRequireWildcardCache() { return cache; }; return cache; }

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } if (obj === null || _typeof(obj) !== "object" && typeof obj !== "function") { return { "default": obj }; } var cache = _getRequireWildcardCache(); if (cache && cache.has(obj)) { return cache.get(obj); } var newObj = {}; var hasPropertyDescriptor = Object.defineProperty && Object.getOwnPropertyDescriptor; for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = hasPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : null; if (desc && (desc.get || desc.set)) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } newObj["default"] = obj; if (cache) { cache.set(obj, newObj); } return newObj; }

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

// import Typography from '@material-ui/core/Typography';
var useStyles = (0, _styles.makeStyles)(function () {
  return {
    flexContainer: {
      display: 'flex',
      position: 'relative',
      flexDirection: 'column',
      alignItems: 'center',
      justifyContent: 'center'
    },
    // bg: {
    //   position: 'absolute',
    //   width: '100%',
    //   height: '100%',
    //   zIndex: -1,
    // },
    box: {
      textAlign: 'center'
    }
  };
});

function textStyleFromText(str, size) {
  var fontSize = Math.max(16, 90 - str.length * 4 - size * 11);
  return {
    fontSize: fontSize
  };
}

var propTypes = {
  width: _propTypes["default"].number,
  height: _propTypes["default"].number,
  values: _propTypes["default"].arrayOf(_propTypes["default"].oneOfType([_propTypes["default"].number, _propTypes["default"].string])),
  config: _propTypes["default"].arrayOf(_propTypes["default"].any) // bgOffset: PropTypes.number,

};
var defaultProps = {
  width: 300,
  height: undefined,
  values: [],
  config: [] // bgOffset: 230,

};

var CounterMeterC = function CounterMeterC(_ref) {
  var width = _ref.width,
      height = _ref.height,
      config = _ref.config,
      values = _ref.values;
  var classes = useStyles();
  console.log('values:', values);
  return _react["default"].createElement("div", {
    style: {
      width: width,
      height: height
    },
    className: classes.flexContainer
  }, values.map(function (v, i) {
    var value = v;

    var _ref2 = config[i] || {},
        _ref2$unit = _ref2.unit,
        unit = _ref2$unit === void 0 ? '' : _ref2$unit,
        transform = _ref2.transform,
        decimals = _ref2.decimals,
        toFloor = _ref2.floor,
        label = _ref2.label,
        precision = _ref2.precision,
        ltOnePrecision = _ref2.ltOnePrecision;

    var prettifyValue = (0, _uiUtils.prettifyNumberWithOptions)({
      precision: precision,
      decimals: decimals,
      toFloor: toFloor,
      ltOnePrecision: ltOnePrecision
    });

    if (config[i]) {
      if (transform) {
        if (typeof transform === 'function') try {
          value = config[i].transform(value);
        } catch (err) {
          console.warn('CounterMeter - config[x].transform failed. Value:', value, 'Transform:', transform);
        } else console.warn('CounterMeter - config[x].transform not of type function. transform is:', transform);
      }
    }

    value = prettifyValue(value);
    return _react["default"].createElement("div", {
      key: label || i,
      className: classes.box,
      style: {
        marginBottom: Math.max(10, 30 - values.length * 8)
      }
    }, _react["default"].createElement("span", {
      style: textStyleFromText("".concat(value).concat(unit), values.length)
    }, R.isNil(value) || Number.isNaN(value) ? '-' : "".concat(value).concat(unit)), _react["default"].createElement("br", null), _react["default"].createElement(_Caption.Caption, {
      label: label || _react["default"].createElement("span", null, "\xA0")
    }));
  }));
};

CounterMeterC.propTypes = propTypes;
CounterMeterC.defaultProps = defaultProps;
var CounterMeter = CounterMeterC;
exports.CounterMeter = CounterMeter;